=== packages/zoltan2/CMakeLists.txt ===
#
# A) Define the package
#

TRIBITS_PACKAGE(Zoltan2)


TRIBITS_ADD_TEST_DIRECTORIES(test)

TRIBITS_ADD_EXAMPLE_DIRECTORIES(example)

#
# D) Do standard postprocessing
#

TRIBITS_PACKAGE_POSTPROCESS()
